<?php
#CMS - CMS Made Simple
#(c)2004 by Ted Kulp (wishy@users.sf.net)
#This project's homepage is: http://www.cmsmadesimple.org
#
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#$Id$

/**
 * Guestbook Module Description
 *
 * What does it do?<br/>
 * The guestbook module is a CMSMS content module and plugin module.<br/>
 * With the Guestbook module you give visitors the ability to leave a message,<br />
 * for example how they like the website.<br/>
 *
 * @package Guestbook
 *
 * @author Krisztian Kishyzi<support@expectmore.at> (original author)
 * @author Victor Katolyk
 * @author Dick Ittmann
 */
class Guestbook extends CMSModule
{
	/**
	 * @var object
	 */
	var $admin;
	/**
	 * @var object
	 */
	var $frontend;
	/**
	 * @var object
	 */
	var $dbhandler;
	/**
	 * @var object
	 */
	var $smiley_handler;
	/**
	 * @var array
	 */
	var $installed_modules;
	/**
	 * @var object
	 */
	var $db;
	
	/**
	 * Module Class constructor
	 */
	function __construct() {
		
		// call the parent constructor
		parent::__construct();
		// add the module plugins dir to the CMS Smarty object
		
		//if(isset($this->cms->smarty->plugins_dir)){
			//$this->cms->smarty->plugins_dir[] = $this->getModulePath() . '/plugins';
		//}else{
			//$smartyobj=$this->cms->GetSmarty()->plugins_dir[] = $this->getModulePath() . '/plugins';
		//}
		// set initial property values		
		$this->admin = NULL;
		$this->frontend = NULL;
		$this->dbhandler = NULL;
		$this->smileyhandler = NULL;
		$this->installed_modules = array();
		$this->db = &$this->GetDB();
		// register content type on CMSMS 1.6 and higher
		// contenttype is depriciate for 1.11.1 maybe i could do this ready for later
		//$this->RegisterContentType('GuestbookContent', cms_join_path(dirname(__FILE__), 'class.GuestbookContent.php'), $this->GetFriendlyName());
	}
	
	/**
	 * The module version number
	*/
	function GetVersion()
	{
		return '1.4_RC2';
	}
	
	/**
	 * Sets module parameters
	*/
	function SetParameters()
	{
		cmsms()->GetSmarty()->addPluginsDir($this->getModulePath() . '/plugins');
		$this->RegisterModulePlugin(FALSE,FALSE);
		$this->RestrictUnknownParams();
		$this->CreateParameter('mode', 'guestbook', $this->Lang('help_mode'));
		$this->SetParameterType('mode', CLEAN_STRING);
		$this->CreateParameter('show_entry', '', $this->Lang('help_show_entry'));
		$this->SetParameterType('show_entry', CLEAN_INT);
		$this->CreateParameter('guestbook', $this->GetPreference('guestbook', '0'), $this->Lang('help_guestbook'));
		$this->SetParameterType('guestbook', CLEAN_INT);
		$this->CreateParameter('shownow', $this->GetPreference('shownow', '0'), $this->Lang('help_shownow'));
		$this->SetParameterType('shownow', CLEAN_STRING);
		$this->CreateParameter('showaddform', $this->GetPreference('showaddform', '0'), $this->Lang('help_showaddform'));
		$this->SetParameterType('showaddform', CLEAN_STRING);
		$this->CreateParameter('textleng', $this->GetPreference('textleng', '1000'), $this->Lang('help_textleng'));
		$this->SetParameterType('textleng', CLEAN_INT);
		$this->CreateParameter('number', $this->GetPreference('number', '10'), $this->Lang('help_number'));
		$this->SetParameterType('number', CLEAN_INT);
		$this->CreateParameter('timespan', $this->GetPreference('timespan', '0'), $this->Lang('help_timespan'));
		$this->SetParameterType('timespan', CLEAN_INT);
		$this->CreateParameter('sortasc', $this->GetPreference('sortasc', '0'), $this->Lang('help_sortasc'));
		$this->SetParameterType('sortasc', CLEAN_STRING);
		$this->CreateParameter('dateformat', $this->GetPreference('dateformat', '%d-%m-%Y %H:%M'), $this->Lang('help_dateformat'));
		$this->SetParameterType('dateformat', CLEAN_STRING);
		$this->CreateParameter('smiley', $this->GetPreference('smiley', '0'), $this->Lang('help_smiley'));
		$this->SetParameterType('smiley', CLEAN_STRING);
		$this->CreateParameter('captcha', $this->GetPreference('captcha', '0'), $this->Lang('help_captcha'));
		$this->SetParameterType('captcha', CLEAN_STRING);
		$this->CreateParameter('hide_insertbutton_after_post', $this->GetPreference('hide_insertbutton_after_post', '0'), $this->Lang('hide_insertbutton_after_post'));
		$this->SetParameterType('hide_insertbutton_after_post', CLEAN_INT);
		$this->CreateParameter('mailnoti', '', $this->Lang('help_mailnoti'));
		$this->SetParameterType('mailnoti', CLEAN_STRING);
		$this->CreateParameter('asplugin', '1', 'Is required if use as smarty tag in sites or templates');
		$this->SetParameterType('asplugin', CLEAN_INT);
		$this->SetParameterType('submit', CLEAN_STRING);
		$this->SetParameterType('entry_submitted', CLEAN_STRING);
		$this->SetParameterType('cancel', CLEAN_STRING);
		$this->SetParameterType('uid', CLEAN_STRING);
		$this->SetParameterType('sender_name', CLEAN_STRING);
		$this->SetParameterType('sender_email', CLEAN_STRING);
		$this->SetParameterType('sender_homepage', CLEAN_STRING);
		$this->SetParameterType('sender_country', CLEAN_STRING);
		$this->SetParameterType('sender_location', CLEAN_STRING);
		$this->SetParameterType('message', CLEAN_STRING);
		$this->SetParameterType('captcha_phrase', CLEAN_STRING);
		
// 		if ($GLOBALS['CMS_VERSION'] < 1.6) {
// 			if (method_exists($this, 'registercontenttype')) { $this->RegisterContentType('GuestbookContent',cms_join_path(dirname(__FILE__),'class.GuestbookContent.php'),$this->GetFriendlyName()); }
// 		}
	}
	
	/**
	 * Returns the name of the module.<br/><br/>
	*/
	function GetName()
	{
		return 'Guestbook';
	}
	
	/**
	 * The name that's shown in the  Admin Menus and section pages
	*/
	function GetFriendlyName()
	{
		return $this->Lang('module_friendlyname');
	}
	
	/**
	 * Alow users to add it in a Page using 'smarty' tag
	*/
	function IsPluginModule()
  {
    return true;
  }
	
	/**
	 * The module should be treated as a content module.
	*/
	function IsContentModule()
	{
		return true;
	}
	
	/**
	 * This module has an Adminarea
	*/
	function HasAdmin()
	{
		return true;
	}
	
	/**
	 * Show or not Show for User with no access to the Module
	*/
	function VisibleToAdminUser()
	{
		return (
				$this->CheckPermission('Modify Guestbook Entries') 
				|| $this->CheckPermission('Modify Guestbook Settings')
				|| $this->CheckPermission('Modify Guestbook Template')
			   ) ? true : false;
	}
	
	/**
	 * Specifies in which Admin Section the module shows
	*/
	function GetAdminSection()
	{
		return 'content';
	}
	
	/**
	 * Required minimal CMS version
	*/
	function MinimumCMSVersion()
	{
		return '1.11';
	}
	
	/**
	 * Description string that gets shown in the Admin Section page that contains the module.
	*/
	function GetAdminDescription()
	{
	return $this->Lang('moddescription');
	}
	
	/**
	 * Message after Module was Installed 
	*/
	function InstallPostMessage()
	{
		return $this->Lang('inposmes', $this->Lang('module_example_stylesheet'));
	}
	
	/**
	 * Message displayed before the Module is uninstalled
	 *
	*/	
	function UninstallPreMessage()
	{
		$encoding = 
			(isset($this->config['admin_encoding']) && $this->config['admin_encoding'] != '') 
			? $this->config['admin_encoding'] 
			: 'UTF-8';
		$msg = html_entity_decode(lang('uninstallconfirm'), ENT_COMPAT, $encoding);
		$msg .= ' ' . $this->getFriendlyName();
		$msg .= ". ";
		$num_entries = $this->GetNumberOfEntries();
		
		if ($num_entries > 0)
		{
			$msg .= 
				$num_entries == 1 
				? html_entity_decode($this->Lang('uninstall_pre_message_single'), ENT_COMPAT, $encoding) 
				: html_entity_decode($this->Lang('uninstall_pre_message', $num_entries), ENT_COMPAT, $encoding);
		}
		return $msg;
	}
	
	/**
	 * Message after Module was uninstalled
	*/
	function UninstallPostMessage()
	{
		return $this->Lang('postuninstall');
	}
	
	/**
	 * Gets an event description
	 * @param string The name of the event
	 * @return string
	*/
	function GetEventDescription($eventname)
	{
		return $this->Lang('event_info_' . $eventname);
	}
	
	/**
	 * Gets help on an event
	 * @param string The name of the event
	 * @return string
	*/
	function GetEventHelp($eventname)
	{
		return $this->Lang('event_help_' . $eventname);
	}
	
	/**
	 * This returns HTML information on the module.
	 *
	 * Typically, you'll want to include information on how to use the module.
	 * See the Language file at /lang/
	 * @param $lang
	 * @return string
	 */
	function GetHelp($lang='en_US')
	{
		return $this->Lang('help');
	}

	/**
	 * This returns a string that is presented in the Module Admin if you click on the "About" link.
	 * @return string
	 */
	function GetAuthor()
	{
		return 'Krisztian Kishazi (original author: up to version 0.6)
			<p>Code contributors:
			<ul>
				<li>Victor Katolyk (version 0.7)</li>
				<li>Dick Ittmann (version 0.8 and on)</li>
				<li>Tobias Kretschmar (version 1.1.10)</li>
				<li>Andi Petzoldt (version 1.1.11 and on)</li>
                <li><a href="mailto:gabr.matias@gmail.com">Gabriel Matias</a> (version 1.3.0 and on)</li>                                
			</ul></p>';
	}
	
	/**
	 * This returns a string that is presented in the Module Admin if you click on the "About" link.
	 * @return string
	 */
	function GetAuthorEmail()
	{
		return '<a href="support@expectmore.at">support@expectmore.at</a>';
	}

	/**
	 * Returns the module changelog.
	 * @return string
	 */
	function GetChangeLog()
	{
		return $this->Lang('changelog');
	}
	
	// End of CMSModule methods	
	
	/**
	 * ShowError to display error 
	 *
	 * @param string $error The Error to display
	 */
	function ShowError($error)
	{
		echo '<p class=\"pageerror\">' . $error . '</p>';
	}
	
	function InsertEntry($guestbook_id, $entry)
	{
		if ($entry->GetTimestamp() == '')
		{
			$timestamp = $this->GetTimestamp('');
			$timestamp = substr($timestamp, 1, strlen($timestamp)-2); // remove surrounding quotes
			$entry->SetTimestamp($timestamp);
		}
		$dbhandler = $this->getDbHandler();
		$result = $dbhandler->InsertEntry($guestbook_id, $entry);
		if ($result)
		{
			if (method_exists($this, 'SendEvent'))
			{
				// send event
				$parms = array(
					'guestbook_id'   => $entry->guestbook_id,
					'entry_id'       => $entry->entry_id,
					'entry_sender'   => $entry->sender->GetName(),
					'entry_email'    => $entry->sender->GetEmail(),
					'entry_homepage' => $entry->sender->GetHomepage(),
					'entry_message'  => $entry->GetMessage(),
					'entry_date'     => $entry->GetTimestamp(),
					'entry_approved' => $entry->IsActive(),
					'entry_country'  => $entry->sender->GetCountry(),
					'entry_location' => $entry->sender->GetLocation(),
					'entry_ip'       => $entry->sender->GetIp()
				);
				$this->SendEvent('GuestbookEntryPosted', $parms);
			}
		}
		
		// add entry to search index
		if ($entry->IsActive()) {
			if ($search = $this->GetModuleInstance('Search'))
			{
				$str = $entry->sender->GetName() . ' ' . $entry->sender->GetCountry() . ' ' . $entry->sender->GetLocation() . ' ' . $entry->GetMessage();
				$search->AddWords($this->GetName(), $entry->entry_id, 'guestbook', $str);
			}
		}
	}
	
	
	
	function GetEntryById($entry_id)
	{
		$dbhandler =& $this->GetDbHandler();
		$result = $dbhandler->GetEntryById($entry_id);
		if ($result)
		{
			$entry =& $this->GetEntryFromData($result->fields);
			return $entry;
		}
	}
	
	function & GetEntryFromData($data)
	{
		require_once cms_join_path($this->GetModulePath(), 'lib', 'classes', 'module', 'class.GuestbookEntry.php');
		require_once cms_join_path($this->GetModulePath(), 'lib', 'classes', 'module', 'class.GuestbookEntrySender.php');
		$sender = new GuestbookEntrySender($data['sender'], $data['e_mail'], $data['ip_address'], $data['country'], $data['location'], $data['homepage']);
		$entry = new GuestbookEntry($sender, $data['message'], $data['approved'] == '1' ? true : false, $data['date']);
		$entry->entry_id = $data['entry_id'];
		$entry->guestbook_id = $data['guestbook'];
        $entry->guestbook_name = $data['guestbook_name'];
		return $entry;
	}
	
	/**
	 * Reads the contents of the example stylesheet css file and writes it to the database
	 */
	function UpdateStylesheet(&$db) 
	{
		// update the stylesheet iserted on install
		# get the stylesheet id
		$query = "SELECT value FROM " . cms_db_prefix() . "module_guestbook_settings WHERE setting = 'template_id'";
		$result =& $this->db->Execute($query);
		$css_id = $result->Fields('value');
		# update the stylesheet
		$css_text =
		# create the css content
		# the intro from the language file
			"/*\n" . $this->Lang('module_example_stylesheet_intro') . "\n*/\n\n"
		# the contents of the css file
			. file_get_contents(cms_join_path($this->GetModulePath(), 'css', 'stylesheet.css'))
		;
		# update the stylesheet in the database
		$query = "UPDATE " . cms_db_prefix() . "css SET css_text = '" . $css_text . "' WHERE css_id = '$css_id'";
		$result =& $this->db->Execute($query);
	}
	
	/**
	 * @param string Name of the module
	 * @return bool Whether the specified module is installed
	*/
	function ModuleIsInstalled($modulename)
	{
		if(isset($this->cms->modules)){
			$listmods=$this->cms->modules;
		}else{
			$modops=$this->cms->GetModuleOperations();
			$listmods=$modops->GetInstalledModules();
		}
		// non-admin modules are listed in $this->cms->modules
		if (isset($listmods[$modulename]))
		{
			return true;
		}
		
		// the module is a module found before
		if (isset($this->installed_modules[$modulename]))
		{
			return true;
		}

		// find modules
		$query = "
			SELECT * FROM " . cms_db_prefix() . "modules 
			WHERE module_name = '$modulename' AND active = 1
		";
			
		$result = $this->db->Execute($query);
		if ($result && $result->RecordCount() > 0)
		{
			$this->installed_modules[$modulename] = 1;
			return true;
		}
			
		return false;
	}

	function SearchResult($returnid, $entry_id, $attr = '')
	{
		// require the GuestbookFrontend class file
		require_once cms_join_path($this->GetModulePath(), 'lib', 'classes', 'module', 'class.GuestbookFrontend.php');

		$result = array();

		if ($attr == 'guestbook')
		{
			$entry = $this->GetEntryById($entry_id);
			if (! $entry)
			{
				echo('error in Guestbook SearchResult');
				// todo, audit
				return;
			}
			if ($this->GetPreference('searchsmileys'))
			{
				$smiley_handler =& $this->GetSmileyHandler();
				$entry->SetMessage($smiley_handler->InsertSmileys($entry->GetMessage()));
			}
			$result[0] = 'Guestbook - ' . $entry->sender->GetName() . ' - ' . $entry->GetMessage();
			$result[1] = 'View Guestbook entry';
			$result[2] = $this->CreateLink(
				$entry_id, 
				'default', 
				$returnid, 
				'',
				array(
					'mode' => 'entry',
					'smiley' => $this->GetPreference('searchsmileys'),
					'show_entry' => $entry_id
				), 
				'', 
				true
			);
			return $result;
		}
	}
	
	function SearchReIndex(&$module)
	{
		$query = "
			SELECT 
				entry_id,
				sender,
				e_mail,
				homepage,
				country,
				location,
				message
			FROM " . cms_db_prefix() . "module_guestbook
			WHERE approved = '1'
		";
		$dbresult = $this->db->Execute( $query );
		if( !$dbresult )
		{
			die( $this->db->ErrorMsg() );
		}
		while( $row = $dbresult->FetchRow() )
		{
			$str = 
				$row['sender']   . ' ' .
//                $row['e_mail']   . ' ' .
//                $row['homepage'] . ' ' .
				$row['country']  . ' ' .
				$row['location'] . ' ' .
				$row['message']
			;
			$module->AddWords( $this->GetName(), $row['entry_id'], 'guestbook', $str );
		}
	}
	
	//TODO should be external insertstylesheet
	function InsertStylesheet() {
		// Create the default/example stylesheet
		# get a unique ID for the CSS
		$new_css_id = $this->db->GenID(cms_db_prefix() . 'css_seq');
		# get a localized name for the Stylesheet
		$css_name = str_replace(array('\\','/', ':', '*', '?', '"', '<', '>', '|'), '_', $this->Lang('module_example_stylesheet')) ; // Fast fix for Windows FS
		# create the css text
		$css_text = '';
		$css_intro = $this->Lang('module_example_stylesheet_intro');
		$css_filelocation = cms_join_path($this->GetModulePath(), 'css', 'stylesheet.css');
		$css_filecontent = file_get_contents($css_filelocation);
		$css_text = "/*\n $css_intro\n*/\n\n $css_filecontent";
		# media type
		$media_type = 'handheld, screen, tv';
		# creation date
		$timestamp = $this->GetTimestamp();
		# create the query
		$css_table = cms_db_prefix() . 'css'; // the table that stores the CMSMS stylesheets
		$query = "
			INSERT INTO 
			`$css_table`
			(css_id, css_name, css_text, media_type, create_date, modified_date) 
			VALUES 
			('$new_css_id', '$css_name', '$css_text', '$media_type', $timestamp, $timestamp)
		";
		# execute the query: adds the stylesheet to the database
		$result = $this->db->Execute($query);
		if ($result) 
		{
			// save the inserted CSS ID in the module settings table so the stylesheet can be deleted on uninstall
			$settings_table = cms_db_prefix() . 'module_guestbook_settings'; // the table that stores the CMSMS stylesheets
			$query = "
				INSERT INTO 
				`$settings_table`
				(setting, value)
				VALUES 
				('template_id', $new_css_id)
			";
			$result = $this->db->Execute($query);
		}
	}
	
	function GetTimestamp($time = '')
	{
		$time = ($time == '') ? time() : $time;
		$timestamp = $this->db->DBTimeStamp($time);
		if ($timestamp[0] != "'")
		{
			$timestamp = "'$timestamp'";
		}
		return $timestamp;
	}
	
	function & GetFrontend($id, $params, $returnid)
	{
		if ($this->frontend == NULL)
		{
		// require the GuestbookDbHandler class file
			require_once cms_join_path($this->GetModulePath(), 'lib', 'classes', 'module', 'class.GuestbookFrontend.php');
			
			$this->frontend = new GuestbookFrontend($this->GetDbHandler(), $gCms->smarty);
			$this->frontend->InitMode($params);
			$this->frontend->InitCaptcha($params['captcha'] == 1 ? true : false);
		}
		return $this->frontend;
	}
	
	function & GetDbHandler()
	{
		// require the GuestbookDbHandler class file
		require_once cms_join_path($this->GetModulePath(), 'lib', 'classes', 'module', 'class.GuestbookDbHandler.php');
		
		if ($this->dbhandler == NULL)
		{
			$this->dbhandler = new GuestbookDbHandler($this->db);
		}
		
		return $this->dbhandler;
	}
	
	function & GetSmileyHandler()
	{
		// require the GuestbookSmileyHandler class file
		require_once cms_join_path($this->GetModulePath(), 'lib', 'classes', 'module', 'class.GuestbookSmileyHandler.php');
		
		if ($this->smileyhandler == NULL)
		{
			$mi = $this->ModuleIsInstalled('Smileys') ? $this->getModuleInstance('Smileys') : NULL;
			$this->smileyhandler = new GuestbookSmileyHandler($mi);
			$this->smileyhandler->ImageBaseURL = $this->cms->config['root_url'] . '/modules/' . $this->GetName() . '/images/smileys/default';
		}
		return $this->smileyhandler;
	}
	
	function GetNumberOfEntries($guestbook_id=NULL, $get_inactive=false)
	{
		$dbhandler =& $this->GetDbHandler();
		$result = $dbhandler->getNumberOfEntries((!isset($guestbook_id) ? NULL : (int) $guestbook_id), (bool) $get_inactive);
		if ($result) {
			return $result->fields['count'];
		}
	}
	
	function GetEntries(&$pagination, $guestbook_id=NULL, $order_by='', $get_inactive=false)
	{
		$entries = array();
		$limit = $pagination->getLimit();
		$index = $pagination->getIndex();
		
		$dbhandler =& $this->GetDbHandler();
		$dbresult = $dbhandler->GetEntries($guestbook_id, $order_by, $get_inactive, $limit, $index);
		if ($dbresult && $dbresult->RecordCount())
		{
			while ($row = $dbresult->FetchRow())
			{
				$entries[$row['entry_id']] =& $this->GetEntryFromData($row);
			}
		}
		return $entries;
	}
	
	function HasContentType()
	{
		return true;
	}	
	
} // end of class Guestbook

# vim:ts=4 sw=4 noet
?>
