<?php

$access = $this->CheckPermission('Modify Guestbook Entries');
if (!$access)
{
	echo $this->ShowError($this->Lang('access_denied'));
	return;
}

// headers/column titles
$headers = array(
	'guestbook' => $this->GetFriendlyName(),
	'id'        => $this->Lang('id'),
	'sender'    => $this->Lang('sender'),
	'e_mail'    => $this->Lang('email'),
	'country'   => $this->Lang('country'),
	'location'  => $this->Lang('location'),
	'homepage'  => $this->Lang('homepage'),
	'message'   => $this->Lang('message'),
	'postdate'  => $this->Lang('postdate'),
	'active'    => $this->Lang('active'),
	'ip'   => $this->Lang('ip_addr')
);
$this->smarty->assign('headers'   , $headers);
$this->smarty->assign('entries_top_template', cms_join_path($this->GetModulePath(), 'templates', 'admin_entries_top.tpl'));

// guestbook entries

// determine selected guestbook
$selected_guestbook = (isset($params['selected_guestbook'])) ? (ctype_digit($params['selected_guestbook']) ? (int) $params['selected_guestbook'] : 'all') : 'all';

$dbhandler =& $this->GetDbHandler();

// show the guestbook selector form
{
	// get available guestbooks from the database
	include_once($this->GetModulePath().'/function.orm.php');
	$guestbookorm = LoadOrm('guestbook');
	$guestbooks=$guestbookorm->GetAllAsArray(false,array('all'=> 'all'));
	$select_options=array_flip($guestbooks);
	// assign the smarty variables for the guestbook selector template
	$this->smarty->assign('selected_guestbook', $selected_guestbook);
	$this->smarty->assign('guestbooks', $guestbooks);
	$this->smarty->assign('formstart', $this->CreateFormStart($id, 'defaultadmin', $returnid));
	// drop down options

	$this->smarty->assign('select_guestbook', $this->CreateInputDropdown($id, 'selected_guestbook', $select_options, '', $selected_guestbook));
	$this->smarty->assign('submit_guestbook_selector', $this->CreateInputSubmit($id, 'select_guestbook_submit', lang('submit')));
	$this->smarty->assign('formend', $this->CreateFormEnd());
	
	// assign the guestbook selector template
	$this->smarty->assign('guestbook_selector_template', cms_join_path($this->GetModulePath(), 'templates', 'admin_guestbook_selector.tpl'));
}
// pagination
{
    require_once(cms_join_path($this->getModulePath(), 'lib', 'classes', 'Pagination.class.php'));
	$pag_id = 'GB_id'.$selected_guestbook; // id used for pagination
    $number_of_entries = $this->GetNumberOfEntries(($selected_guestbook == 'all' ? NULL : $selected_guestbook), true);
    $pagination = new Pagination($pag_id, $number_of_entries, $this->GetPreference('admin_entries_per_page'), $pag_id);
	$pagination->setUrl($this->CreateLink($id, 'defaultadmin', $returnid, '', array('selected_guestbook' => $selected_guestbook), '', TRUE));
	$pagination->assignArray($this->smarty);
}
// entries
{	
	$entries =& $this->GetEntries($pagination, $selected_guestbook == 'all' ? NULL : $selected_guestbook, '', TRUE);

	// * create the table rows
	
	// images
	$themeObject  = (isset($gCms->variables['admintheme']) ? $gCms->variables['admintheme'] : '');
	$images = array();
	$images['true']   = $themeObject->DisplayImage('icons/system/true.gif'  , $this->Lang('deakti'), '', '', 'systemicon');
	$images['false']  = $themeObject->DisplayImage('icons/system/false.gif' , $this->Lang('ativi') , '', '', 'systemicon');
	$images['edit']   = $themeObject->DisplayImage('icons/system/edit.gif'  , lang('edit')         , '', '', 'systemicon');
	$images['delete'] = $themeObject->DisplayImage('icons/system/delete.gif', lang('delete')       , '', '', 'systemicon');

	// append rowdata to the entry objects
	foreach($entries as $entry)
	{
		$entry->rowdata = array();
		$entry->rowdata['edit_link'] = $this->CreateLink($id, 'entry-edit', $returnid, $images['edit'], array('entry_id' => $entry->entry_id, 'selected_guestbook' => $selected_guestbook));
		$delconf = lang('deleteconfirm', $entry->entry_id);
		$entry->rowdata['delete_link'] = $this->CreateLink($id, 'entry-delete', $returnid, $images['delete'], array('entry_id' => $entry->entry_id, 'selected_guestbook' => $selected_guestbook), $delconf);
		$entry->rowdata['select_entry_checkbox'] = $this->CreateInputCheckbox($id, 'multi_entry[]', $entry->entry_id, '');
		
		if ($entry->IsActive())
		{
			$entry->rowdata['de_activate_link'] = $this->CreateLink($id, 'entry-deactivate', $returnid, $images['true'] , array('entry_id' => $entry->entry_id, 'selected_guestbook' => $selected_guestbook), $this->Lang('deaktimes'));
		}
		else
		{
			$entry->rowdata['de_activate_link'] = $this->CreateLink($id, 'entry-activate'  , $returnid, $images['false'], array('entry_id' => $entry->entry_id, 'selected_guestbook' => $selected_guestbook), $this->Lang('ativimes'));
		}
		
	}
	$smarty->assign('entries', $entries);
	
	// assign template
	$this->smarty->assign('entry_template', cms_join_path($this->GetModulePath(), 'templates', 'admin_entries_entry.tpl'));
}

// table bottom
{ 
	// admin bottom (new entry link and multi-entry select and submit)

	// Image and link to add a new guestbook entry
	$guestbook = $selected_guestbook == 'all' ? $this->GetPreference('guestbook') : $selected_guestbook;
	$this->smarty->assign(
		'add_entry_link',
		$this->CreateLink(
			$id,
			'entry-add',
			$returnid,
			$gCms->variables['admintheme']->DisplayImage(
				'icons/system/newobject.gif', $this->Lang('addgait'), '', '', 'systemicon'
			),
			array('guestbook' => $guestbook, 'selected_guestbook' => $selected_guestbook),
			'',
			false,
			false,
			''
		) . ' ' . $this->CreateLink(
			$id,
			'entry-add', 
			$returnid,
			$this->Lang('addgait'),
			array('guestbook' => $guestbook, 'selected_guestbook' => $selected_guestbook),
			'', 
			false,
			false,
			'class="pageoptions"'
		)
	);
	
	// Multi select form start
	$this->smarty->assign('multi_formstart', $this->CreateFormStart($id, 'entry-multi', $returnid));
	// Multi select title
	$this->smarty->assign('selected_items_title', lang('selecteditems'));

	// Items for the multi-select action dropdown
	$items = array(
		$this->Lang('ativi')  => 'activate',
		$this->Lang('deakti') => 'deactivate',
		lang('delete')        => 'delete'
	);
	// Multi-select action dropdown
	$this->smarty->assign('action_dropdown', $this->CreateInputDropDown($id, 'multiaction', $items));

	// Multi-select submit button
	$this->smarty->assign('multi_submit', $this->CreateInputSubmit($id, 'submit', lang('submit')));
	
	$this->smarty->assign('entries_bottom_template', cms_join_path($this->GetModulePath(), 'templates', 'admin_entries_bottom.tpl'));
}
$this->smarty->assign('mod', $this);

// set the tab contents
$tab =& $this->admin->tabs['entries'];
echo $this->ProcessTemplate('admin_tab_entries.tpl');

?>