<?php
$access=($this->CheckPermission('Modify Guestbook Entries') || $this->CheckPermission('Modify Guestbook Settings') || $this->CheckPermission('Modify Guestbook Template'));
if (!$access)
{
	echo $this->ShowError($this->Lang('access_denied'));
	return;
}
// headers/column titles
$headers = array(
	'id'          => $this->Lang('id'),
	'name'        => $this->Lang('inam'),
	'description' => $this->Lang('description'),
	'default'     => $this->Lang('default'),
	'active'      => $this->Lang('active'),
	'edit'        => lang('edit'),
	'delete'      => lang('delete')
);

$this->smarty->assign('headers', $headers);

// images
$themeObject  = $gCms->variables['admintheme'];
$images = array();
$images['true']   = $themeObject->DisplayImage('icons/system/true.gif'  , $this->Lang('deakti'), '', '', 'systemicon');
$images['false']  = $themeObject->DisplayImage('icons/system/false.gif' , $this->Lang('ativi') , '', '', 'systemicon');
$images['edit']   = $themeObject->DisplayImage('icons/system/edit.gif'  , lang('edit')         , '', '', 'systemicon');
$images['delete'] = $themeObject->DisplayImage('icons/system/delete.gif', lang('delete')       , '', '', 'systemicon');

$default_guestbook = $this->GetPreference('guestbook');

// get the guestbooks
include_once($this->GetModulePath().'/function.orm.php');
$guestbookorm = LoadOrm('guestbook');
$dbresult=$guestbookorm->GetAll(true);
$guestbooks=array();
if($dbresult && $dbresult->RecordCount()>0)
{
	$guestbookorm->resetrowclass();
	while($row = $dbresult->FetchRow())
	{
		$guestbook = $guestbookorm->RowAsStd($row);
		$guestbook->rowdata = array();
		$guestbook_id = $guestbook->id;
		// edit link
		$guestbook->rowdata['edit_link'] = $this->CreateLink($id, 'guestbook-edit', $returnid, $images['edit'], array('guestbook_id' => $guestbook_id));
		
		// delete link, default guestbook cannot be deleted
		$guestbook->rowdata['delete_link'] = ($guestbook_id != $default_guestbook)?$this->CreateLink($id, 'guestbook-delete', $returnid, $images['delete'], array('guestbook_id' => $guestbook_id),
				$this->Lang('confirm_delete_guestbook', array($guestbook_id, $this->GetNumberOfEntries($guestbook_id, TRUE)))):'';
		
		// activate or de-activate link
		if ($guestbook->isactive)
		{
			// default guestbook cannot be de-activated
			if ($guestbook_id != $default_guestbook)
			{
				$guestbook->rowdata['de_activate_link'] = $this->CreateLink($id, 'guestbook-deactivate', $returnid, $images['true'] , array('guestbook_id' => $guestbook_id), '');
			}
			else
			{
				$guestbook->rowdata['de_activate_link'] = $images['true'];
			}
		}
		else
		{
			$guestbook->rowdata['de_activate_link'] = $this->CreateLink($id, 'guestbook-activate'  , $returnid, $images['false'], array('guestbook_id' => $guestbook_id), '');
		}
		
		// "set as default" link, only active guestbooks can be set as default
		if ($guestbook_id == $default_guestbook)
		{
			$guestbook->rowdata['default_link'] =
			$themeObject->DisplayImage('icons/system/true.gif', $this->Lang('current_default'), '', '', 'systemicon');
		}
		else
		{
			$image_false = $themeObject->DisplayImage('icons/system/false.gif' , $this->Lang('set_as_default') , '', '', 'systemicon');
			if ($guestbook->isactive)
			{
				$guestbook->rowdata['default_link'] = $this->CreateLink($id, 'guestbook-set-default', $returnid, $image_false, array('guestbook_id' => $guestbook_id), $this->Lang('confirm_set_as_default'));
			}
			else
			{
				$guestbook->rowdata['default_link'] = $image_false;
			}
		}
		
		// Checkbox
		$guestbook->rowdata['select_checkbox'] = $this->CreateInputCheckbox($id, 'multi_guestbook[]', $guestbook_id, '');
		$guestbooks[$row['id']] = $guestbook;
	
	}
}

$smarty->assign('guestbooks', $guestbooks);

// table bottom
{ 
	// admin bottom (new entry link and multi-entry select and submit)

	// Add Guestbook image(link) and link
	$this->smarty->assign(
		'add_guestbook_link',
		$this->CreateLink(
			$id,
			'guestbook-add',
			$returnid,
			$gCms->variables['admintheme']->DisplayImage(
				'icons/system/newobject.gif', $this->Lang('add_guestbook'), '', '', 'systemicon'
			),
			array(),
			'',
			false,
			false,
			''
		) . ' ' . $this->CreateLink(
			$id,
			'guestbook-add', 
			$returnid,
			$this->Lang('add_guestbook'),
			array(),
			'', 
			false,
			false,
			'class="pageoptions"'
		)
	);
	
	// Multi select form start
	$this->smarty->assign('multi_formstart', $this->CreateFormStart($id, 'guestbook-multi', $returnid));
	// Multi select title
	$this->smarty->assign('selected_items_title', lang('selecteditems'));

	// Items for the multi-select action dropdown
	$items = array(
		$this->Lang('ativi')  => 'activate',
		$this->Lang('deakti') => 'deactivate',
		lang('delete')        => 'delete'
	);
	
	// Multi select-title
	$this->smarty->assign('selected_items_title', lang('selecteditems'));
	
	// Multi-select action dropdown
	$this->smarty->assign('action_dropdown', $this->CreateInputDropDown($id, 'multiaction', $items));

	// Multi-select submit button
	$this->smarty->assign('multi_submit', $this->CreateInputSubmit($id, 'submit', lang('submit')));

	// Form end
	$this->smarty->assign('formend', $this->CreateFormEnd());
	
}
echo $this->ProcessTemplate('admin_tab_guestbooks.tpl');


?>