<?php

// no direct access
if (!isset($gCms)) 
{
	exit(); 
}
// check login
check_login();

if (! $this->CheckPermission('Modify Guestbook Entries'))
{
    echo $this->ShowError($this->Lang('access_denied'));
}
else
{
// 	$admin =& $this->GetAdmin($id, $params, $returnid);
//     $admin->AdminForm($id, 'completeadd', $params['guestbook']);

	$params1=array();
	$params1['active_tab']='entries';
	if (isset($params['cancel_guestbook_add']))
	{
	
		$params1['tab_message']='admin_cancel_message';
		$this->Redirect($id,'defaultadmin',$returnid,$params1);
	}
	
	include_once($this->GetModulePath().'/function.orm.php');
	
	$entryorm = LoadOrm('entry');
	
	
	$fieldsarray=array('guestbook','sender','e_mail','homepage','message','country','location','date');
	
	foreach($fieldsarray as $key=>$value)
	{
		$$value = (isset($params[$value])?$params[$value]:"");
	}
	
	
	$error = '';
	if (isset($params['submit']))
	{
	
		$validinfo = true;
	
		 
		$returnedid=false;
		$now = date("Y-m-d H:i:s");
		if (preg_match('/(\d+)\D(\d+)\D(\d+)\D(\d+)\D(\d+)\D(\d+)/',$params['date'],$tmp_date)) {
			$date = sprintf('%04d-%02d-%02d %02d:%02d:%02d', $tmp_date[1], $tmp_date[2], $tmp_date[3], $tmp_date[4], $tmp_date[5], $tmp_date[6]);
		}
		else {
			$date = $params['date'];
			$error .= "<li>" . $this->Lang('wrong_date_format') . "</li>";
			$validinfo = false;
		}
	
		if (trim($sender) == '')
		{
			$error .= "<li>" . $this->Lang('admin_entry_message_nosender') . "</li>";
			$validinfo = false;
		}
	
	
	
		if($validinfo)
		{
			$entry = $entryorm->GetNewOrmObject();
			foreach($fieldsarray as $key=>$value)
			{
				$entry->SetVariable($value,$$value);
			}
			$returnedid=$entry->save();
			$this->Audit($returnedid,$this->GetName(),$this->Lang('admin_entry_added_logmessage'));
			$params1['tab_message']='admin_entry_added_logmessage';
			$this->Redirect($id,'defaultadmin',$returnid,$params1);
		}
	
	
	}
	
	
	
	
	$this->smarty->assign('errormsg', $error);
	
	$this->smarty->assign('input_hidden_guestbook', $this->CreateInputHidden($id, 'guestbook', $guestbook));
	
	$this->smarty->assign('formstart'     , $this->CreateFormStart($id, 'entry-add'));
	
	
	$guestbookorm = LoadOrm('guestbook');
	$guestbooks=$guestbookorm->GetAllAsArray(false);
	$select_options=array_flip($guestbooks);
	$this->smarty->assign('guestbooks', $guestbooks);
	
	$this->smarty->assign('guestbook_title'  , $this->Lang('module_friendlyname'));
	$this->smarty->assign('guestbook'        , $this->CreateInputDropdown($id, 'guestbook', $select_options, '', $guestbook));
	
	$this->smarty->assign('sender_title'  , $this->Lang('sender'));
	$this->smarty->assign('sender'        , $this->CreateInputText($id, 'sender', $sender  , '', 255));
	
	$this->smarty->assign('e_mail_title'  , $this->Lang('email'));
	$this->smarty->assign('e_mail'        , $this->CreateInputText($id, 'e_mail'  , $e_mail  , '', 255));
	
	$this->smarty->assign('date_title'    , $this->Lang('date'));
	$this->smarty->assign('date'          , $this->CreateInputText($id, 'date'  , $date ? $date : date("Y-m-d H:i:s")  , '', 255));
	
	$this->smarty->assign('country_title' , $this->Lang('country'));
	$this->smarty->assign('country'       , $this->CreateInputText($id, 'country' , $country , '', 255));
	
	$this->smarty->assign('location_title', $this->Lang('location'));
	$this->smarty->assign('location'	  , $this->CreateInputText($id, 'location' , $location , '', 255));
	
	$this->smarty->assign('homepage_title', $this->Lang('homepage'));
	$this->smarty->assign('homepage'      , $this->CreateInputText($id, 'homepage', $homepage, '', 255));
	
	$this->smarty->assign('message_title' , $this->Lang('message'));
	$this->smarty->assign('message'       , $this->CreateTextarea(true, $id, $message, 'message', 'syntaxHighlight', 'message'));
	
	
	$this->smarty->assign('submit'        , $this->CreateInputSubmit($id, 'submit', Lang('submit')));
	$this->smarty->assign('cancel'        , $this->CreateInputSubmit($id, 'cancelsubmit', Lang('cancel')));
	
	$this->smarty->assign('formend'       , $this->CreateFormEnd());
	
	echo $this->ProcessTemplate('admin_entry.tpl');
	
}

?>