<?php

// no direct access
if (!isset($gCms))
{
	exit();
}
// check login
check_login();

// check permission

// user doesn't have sufficient privileges
if (! $this->CheckPermission('Modify Guestbook Entries'))
{
	// show an error message
	echo $this->ShowError($this->Lang('access_denied'));
	return;
}
include_once($this->GetModulePath().'/function.orm.php');

$params1=array();
$params1['active_tab']='guestbooks';
if (isset($params['cancel_guestbook_edit']))
{
	
	$params1['tab_message']='admin_cancel_message';
	$this->Redirect($id,'defaultadmin',$returnid,$params1);
}
$guestbookID = (isset($params['guestbook_id'])?$params['guestbook_id']:'');
$guestbookorm = LoadOrm('guestbook');
$error = '';
if (isset($params['submit_guestbook_edit']))
{

	$validinfo = true;
		
	$name = (isset($params['guestbook_name'])?$params['guestbook_name']:"");
	$descr = (isset($params['guestbook_description'])?$params['guestbook_description']:'');
	$active=$params['guestbook_active'] == 1 ? true : false;
	$returnedid=false;

	if ($name == "")
	{
		$error .= $this->Lang('fabsend');
		$validinfo = false;
	}



	if($validinfo)
	{
		$returnedid=$guestbookorm->GuestbookGuestbook($name, $descr, $active,$guestbookID);
		$this->Audit($returnedid,$this->GetName(),$this->Lang('admin_guestbook_edit_logmessage'));
		$params1['tab_message']='admin_guestbook_edit_logmessage';
		$this->Redirect($id,'defaultadmin',$returnid,$params1);
	}

	 
}
else {
	$guestbook = $guestbookorm->GetByID($guestbookID,true);
	$name=$guestbook->GetVariable('name');
	$descr=$guestbook->GetVariable('descr');
	$active=$guestbook->GetVariable('active');
}

$this->ShowError($error);

$smarty->assign('formstart', $this->CreateFormStart($id, 'guestbook-edit', $returnid, 'post', '', '', '', array('guestbook_id' => $params['guestbook_id'])));


$smarty->assign('title', $this->Lang('editing_guestbook'));
$smarty->assign('name_title', $this->Lang('inam'));
$smarty->assign('name', $this->CreateInputText($id, 'guestbook_name', $name, '24', '255', ''));
$smarty->assign('description_title', $this->Lang('description'));
$smarty->assign('description', $this->CreateInputText($id, 'guestbook_description', $descr, '48', '255', ''));
$smarty->assign('active_title', Lang('active'));
$smarty->assign('active', $this->CreateInputRadioGroup($id, 'guestbook_active', array(Lang('true') => 1, Lang('false') => 0), $active ? 1 : 0, '', '&nbsp;'));
$smarty->assign('submit', $this->CreateInputSubmit($id, 'submit_guestbook_edit', lang('edit')));
$smarty->assign('cancel', $this->CreateInputSubmit($id, 'cancel_guestbook_edit', lang('cancel')));

$smarty->assign('formend', $this->CreateFormEnd());

echo $this->ProcessTemplate('admin_guestbooks_add_edit.tpl');

?>