<?php
#CMS - CMS Made Simple
#(c)2004 by Ted Kulp (wishy@users.sf.net)
#This project's homepage is: http://cmsmadesimple.sf.net
#
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#$Id$
  
/**
 * Guestbook Module Description
 *
 * What does it do?<br/>
 * The GuestbookModule Class extends the Contenttypes.<br/>
 * It would be created to allow easier access to the guestbook module settings.<br/>
 * this is depriciate for now because CMSMS not work with this maybe it need a redesign.
 *
 * @package Guestbook
 * @subpackage CMSModuleContentType
 * @author Krisztian Kishyzi<support@expectmore.at>
 * @author Victor Katolyk
 * @author Dick Ittmann
*/
class GuestbookContent extends CMSModuleContentType
{
    protected $cms;
    protected $mod;
    
    /*function __construct(){
		parent::__construct();
        $this->init_set();
    }
    
    function __wakeup(){
        $this->init_set();
    }
    */
    function init_set(){
		$this->cms = cmsms();
		if(isset($this->cms->modules)){
			$this->mod = $this->cms->modules['Guestbook']['object'];
		}else{
			$modops = $this->cms->GetModuleOperations();
			$this->mod = $modops->get_module_instance('Guestbook');
		}
    }

	function SetProperties()
	{
      $this->AddBaseProperty('string', 'number'     , '');
		$this->AddBaseProperty('string', 'textleng'   , '');
		$this->AddBaseProperty('string', 'dateformat' , '');
		$this->AddBaseProperty('string', 'mailnoti');
		$this->AddBaseProperty('string', 'locale');
		$this->AddBaseProperty('string', 'timespan'   , '0');
		$this->AddBaseProperty('bool',   'smiley'     , false);
		$this->AddBaseProperty('bool',   'captcha'    , false);
		$this->AddBaseProperty('bool',   'sortasc'    , false);
		$this->AddBaseProperty('bool',   'shownow'    , false);
		$this->AddBaseProperty('bool',   'showaddform', false);
      $this->AddBaseProperty('int',   'guestbook', 0);
		$this->SetCachable(false);
		#Turn on preview
		$this->mPreview = true;
	}

	function EditAsArray($adding=false, $tab=0, $showadmin=false)
	{
		$config = cmsms()->GetConfig();
		
		$use_ops = method_exists(cmsms(), 'getcontentoperations');
		if ($use_ops)
		{
			$content_ops  =& cmsms()->GetContentOperations();
			$template_ops =& cmsms()->GetTemplateOperations();
		}

        $ret = array();
		if($tab==0){
            $ret[] = array(lang('title')    . ':', '<input type="text" name="title"    value="' . $this->mName     . '">');
            $ret[] = array(lang('menutext') . ':', '<input type="text" name="menutext" value="' . $this->mMenuText . '">');
    		if (!($config['auto_alias_content'] == true && $adding))
    		{
    			$ret[] = array(lang('pagealias') . ':' , '<input type="text" name="alias" value="' . $this->mAlias . '" />');
    		}
            $ret[] = array('&nbsp;', '');
            
            $dropdown = $use_ops ? $template_ops->TemplateDropdown('template_id', $this->mTemplateId) : TemplateOperations::TemplateDropdown('template_id', $this->mTemplateId);
            $ret[] = array(lang('template')           . ':', $dropdown);
            $dropdown = $use_ops ? $content_ops->CreateHierarchyDropdown($this->mId, $this->mParentId) : ContentManager::CreateHierarchyDropdown($this->mId, $this->mParentId);
            $ret[] = array(lang('parent')             . ':', $dropdown);
            $ret[] = array('&nbsp;', '');
            
            // now do advanced attributes
            $ret[] = array(lang('active')             . ':', '<input type="checkbox" name="active"'       . ($this->mActive     ? ' checked="checked"' : '') . '>');
            $ret[] = array(lang('showinmenu')         . ':', '<input type="checkbox" name="showinmenu"'   . ($this->mShowInMenu ? ' checked="checked"' : '') . '>');
            
            if(!$adding && $showadmin){
                $userops = cmsms()->GetUserOperations();
                array_push($ret, array(lang('owner'),@$userops->GenerateDropdown($this->Owner())));
            }
        	if($adding || $showadmin){
                array_push($ret, $this->ShowAdditionalEditors());
            }
            
            // if adding, the last modified informations are not yet defined
            if(!$adding){
                $tmp = get_preference(get_userid(),'date_format_string','%x %X');
        	    if( empty($tmp) ) $tmp = '%x %X';
        	    $ret[]=array(lang('last_modified_at').':', strftime($tmp, strtotime($this->mModifiedDate) ) );
        	    $userops =& cmsms()->GetUserOperations();
        	    $modifiedbyuser = $userops->LoadUserByID($this->mLastModifiedBy);
        	    if($modifiedbyuser) $ret[]=array(lang('last_modified_by').':', $modifiedbyuser->username);
            }
        }
        if($tab==1){


            $selectedvalue = $this->GetPropertyValue('dateformat');
            $dropdownitems = array(
                'dd-mm-yyyy HH:MM' => '%d-%m-%Y %H:%M',
                'dd/mm/yyyy HH:MM' => '%d/%m/%Y %H:%M',
                'dd.mm.yyyy HH:MM' => '%d.%m.%Y %H:%M',
                'dd-mm-yyyy HH:MM:SS' => '%d-%m-%Y %H:%M:%S',
                'dd/mm/yyyy HH:MM:SS' => '%d/%m/%Y %H:%M:%S',
                'dd.mm.yyyy HH:MM:SS' => '%d.%m.%Y %H:%M:%S',
                'dd-mm-yyyy HHhMM' => '%d-%m-%Y %Hh%M',
                'dd/mm/yyyy HHhMM' => '%d/%m/%Y %Hh%M',
                'dd.mm.yyyy HHhMM' => '%d.%m.%Y %Hh%M',
                'd Month yyyy HH:MM' => '%e %B %Y %H:%M',
                'd Month yyyy HH:MM:SS' => '%e %B %Y %H:%M:%S',
                'd Month yyyy HHhMM' => '%e %B %Y %Hh%M',
            	'dd-mm-yyyy' => '%d-%m-%Y',
                'dd/mm/yyyy' => '%d/%m/%Y', 
            	'dd.mm.yyyy' => '%d.%m.%Y', 
            	'yyyy-mm-dd' => '%Y-%m-%d',
                'yyyy/mm/dd' => '%Y/%m/%d', 
            	'yyyy.mm.dd' => '%Y.%m.%d' 
            );
            


            $text = '<select name="dateformat">';
            

            $count = 0;
            foreach ($dropdownitems as $key => $value)
            {

            	$text .= '<option value="' . $value . '"';
            	if ((isset($selectedindex) && $selectedindex == $count) || $selectedvalue == $value)
            	{

            		$text .= ' ' . 'selected="selected"';
            	}

            	$text .= '>';
            	$text .= $key;
            	$text .= '</option>';
            	$count++;
            }
            


            $text .= '</select>' . "\n";
            
        	// get available guestbooks from the database
//         	// drop down options
//         	$select_options = array();
//         	foreach($guestbooks as $guestbook_id => $guestbook)
//         	{
//         		$select_options[$guestbook->name] = $guestbook_id;
//         	}
        	include_once(dirname(__FILE__).'/function.orm.php');
        	$guestbookorm = LoadOrm('guestbook');
        	$guestbooks=$guestbookorm->GetAllAsArray(false);
        	$select_options=array_flip($guestbooks);
            
        	// assign the guestbook selector template
        	$ret[] = array($this->Lang('module_friendlyname')      . ':', $this->GetModuleInstance()->CreateInputDropdown('', 'guestbook', $select_options, '', $this->GetPropertyValue('guestbook')));
            $ret[] = array($this->Lang('nummer')      . ':', '<input type="text" name="number" value="'   . $this->GetPropertyValue('number')   . '">');
            $ret[] = array($this->Lang('postchar')    . ':', '<input type="text" name="textleng" value="' . $this->GetPropertyValue('textleng') . '">');
            $ret[] = array($this->Lang('emailnot')    . ':', '<textarea name="mailnoti">' . $this->GetPropertyValue('mailnoti') . '</textarea>');
            $ret[] = array($this->Lang('lang')        . ':', '<input type="text" name="lang" value="'     . $this->GetPropertyValue('locale')   . '">');
            $ret[] = array($this->Lang('timespan')    . ':', '<input type="text" name="timespan" value="' . $this->GetPropertyValue('timespan') . '">');
            $ret[] = array($this->Lang('datefora')    . ':', $text);
            
            $ret[] = array($this->Lang('showaddform') . ':', '<input type="checkbox" name="showaddform" ' . ($this->GetPropertyValue('showaddform') == 1 ? ' checked="checked"' : '') . ' value="1">');
            $ret[] = array($this->Lang('sortasc')     . ':', '<input type="checkbox" name="sortasc" '     . ($this->GetPropertyValue('sortasc')     == 1 ? ' checked="checked"' : '') . ' value="1">');
            $ret[] = array($this->Lang('smile')       . ':', '<input type="checkbox" name="smiley" '      . ($this->GetPropertyValue('smiley')      == 1 ? ' checked="checked"' : '') . ' value="1">');
            

            if ($this->GetModuleInstance()->ModuleIsInstalled('Captcha'))
            {
            	$ret[] = array($this->Lang('captcha')     . ':', '<input type="checkbox" name="captcha" '     . ($this->GetPropertyValue('captcha')     == 1 ? ' checked="checked"' : '') . ' value="1">');
            }
            $ret[] = array($this->Lang('shmenow')     . ':', '<input type="checkbox" name="shownow" '     . ($this->GetPropertyValue('shownow')     == 1 ? ' checked="checked"' : '') . ' value="1">');
        }
        
        return $ret;
	}
	
	function ModuleName()
	{
		return 'Guestbook';
	}
	    
	function Edit($adding=false, $tab=0, $showadmin=false)
	{               
		$config = $this->cms->config;
		
		$use_ops = method_exists($this->cms, 'getcontentoperations');
		if ($use_ops)
		{
			$content_ops  =& $this->cms->GetContentOperations();
			$template_ops =& $this->cms->GetTemplateOperations();
		}

        $ret = array();
		if($tab==0){
            $ret .= '<tr><td>'.lang('title')    . ':</td><td>'.'<input type="text" name="title"    value="' . $this->mName     . '">'.'</td></tr>';
            $ret .= '<tr><td>'.lang('menutext') . ':</td><td>'.'<input type="text" name="menutext" value="' . $this->mMenuText . '">'.'</td></tr>';
    		if (!($config['auto_alias_content'] == true && $adding))
    		{
    			$ret .= '<tr><td>'.lang('pagealias') . ':' .'</td><td>'.'<input type="text" name="alias" value="' . $this->mAlias . '" />'.'</td></tr>';
    		}
            $ret .= '<tr><td>'.'&nbsp;'.'</td><td>'.''.'</td></tr>';
            
            $dropdown = $use_ops ? $template_ops->TemplateDropdown('template_id', $this->mTemplateId) : TemplateOperations::TemplateDropdown('template_id', $this->mTemplateId);
            $ret .= '<tr><td>'.lang('template')           . ':</td><td>'.$dropdown.'</td></tr>';
            $dropdown = $use_ops ? $content_ops->CreateHierarchyDropdown($this->mId, $this->mParentId) : ContentManager::CreateHierarchyDropdown($this->mId, $this->mParentId);
            $ret .= '<tr><td>'.lang('parent')             . ':</td><td>'.$dropdown.'</td></tr>';
            $ret .= '<tr><td>'.'&nbsp;'.'</td><td>'.''.'</td></tr>';
            
            // now do advanced attributes
            $ret .= '<tr><td>'.lang('active')             . ':</td><td>'.'<input type="checkbox" name="active"'       . ($this->mActive     ? ' checked="checked"' : '') . '>'.'</td></tr>';
            $ret .= '<tr><td>'.lang('showinmenu')         . ':</td><td>'.'<input type="checkbox" name="showinmenu"'   . ($this->mShowInMenu ? ' checked="checked"' : '') . '>'.'</td></tr>';
            
            if(!$adding && $showadmin){
                $userops = $this->cms->GetUserOperations();
                array_push($ret, array(lang('owner'),@$userops->GenerateDropdown($this->Owner())));
            }
        	if($adding || $showadmin){
                array_push($ret, $this->ShowAdditionalEditors());
            }
            
            // if adding, the last modified informations are not yet defined
            if(!$adding){
                $tmp = get_preference(get_userid(),'date_format_string','%x %X');
        	    if( empty($tmp) ) $tmp = '%x %X';
        	    $ret[]=array(lang('last_modified_at').':', strftime($tmp, strtotime($this->mModifiedDate) ) );
        	    $userops =& $this->cms->GetUserOperations();
        	    $modifiedbyuser = $userops->LoadUserByID($this->mLastModifiedBy);
        	    if($modifiedbyuser) $ret[]=array(lang('last_modified_by').':', $modifiedbyuser->username);
            }
        }
        if($tab==1){


            $selectedvalue = $this->GetPropertyValue('dateformat');
            $dropdownitems = array(
                'dd-mm-yyyy HH:MM' => '%d-%m-%Y %H:%M',
                'dd/mm/yyyy HH:MM' => '%d/%m/%Y %H:%M',
                'dd.mm.yyyy HH:MM' => '%d.%m.%Y %H:%M',
                'dd-mm-yyyy HH:MM:SS' => '%d-%m-%Y %H:%M:%S',
                'dd/mm/yyyy HH:MM:SS' => '%d/%m/%Y %H:%M:%S',
                'dd.mm.yyyy HH:MM:SS' => '%d.%m.%Y %H:%M:%S',
                'dd-mm-yyyy HHhMM' => '%d-%m-%Y %Hh%M',
                'dd/mm/yyyy HHhMM' => '%d/%m/%Y %Hh%M',
                'dd.mm.yyyy HHhMM' => '%d.%m.%Y %Hh%M',
                'd Month yyyy HH:MM' => '%e %B %Y %H:%M',
                'd Month yyyy HH:MM:SS' => '%e %B %Y %H:%M:%S',
                'd Month yyyy HHhMM' => '%e %B %Y %Hh%M',
            	'dd-mm-yyyy' => '%d-%m-%Y',
                'dd/mm/yyyy' => '%d/%m/%Y', 
            	'dd.mm.yyyy' => '%d.%m.%Y', 
            	'yyyy-mm-dd' => '%Y-%m-%d',
                'yyyy/mm/dd' => '%Y/%m/%d', 
            	'yyyy.mm.dd' => '%Y.%m.%d' 
            );
            


            $text = '<select name="dateformat">';
            

            $count = 0;
            foreach ($dropdownitems as $key => $value)
            {

            	$text .= '<option value="' . $value . '"';
            	if ((isset($selectedindex) && $selectedindex == $count) || $selectedvalue == $value)
            	{

            		$text .= ' ' . 'selected="selected"';
            	}

            	$text .= '>';
            	$text .= $key;
            	$text .= '</option>';
            	$count++;
            }
            


            $text .= '</select>' . "\n";
            
        	// get available guestbooks from the database
            include_once(dirname(__FILE__).'/function.orm.php');
            $guestbookorm = LoadOrm('guestbook');
            $guestbooks=$guestbookorm->GetAllAsArray(false);
            $select_options=array_flip($guestbooks);
            
        	// assign the guestbook selector template
        	$ret .= '<tr><td>'.$this->Lang('module_friendlyname')      . ':</td><td>'.$this->mod->CreateInputDropdown('', 'guestbook', $select_options, '', $this->GetPropertyValue('guestbook')).'</td></tr>';
            $ret .= '<tr><td>'.$this->Lang('nummer')      . ':</td><td>'.'<input type="text" name="number" value="'   . $this->GetPropertyValue('number')   . '">'.'</td></tr>';
            $ret .= '<tr><td>'.$this->Lang('postchar')    . ':</td><td>'.'<input type="text" name="textleng" value="' . $this->GetPropertyValue('textleng') . '">'.'</td></tr>';
            $ret .= '<tr><td>'.$this->Lang('emailnot')    . ':</td><td>'.'<textarea name="mailnoti">' . $this->GetPropertyValue('mailnoti') . '</textarea>'.'</td></tr>';
            $ret .= '<tr><td>'.$this->Lang('lang')        . ':</td><td>'.'<input type="text" name="lang" value="'     . $this->GetPropertyValue('locale')   . '">'.'</td></tr>';
            $ret .= '<tr><td>'.$this->Lang('timespan')    . ':</td><td>'.'<input type="text" name="timespan" value="' . $this->GetPropertyValue('timespan') . '">'.'</td></tr>';
            $ret .= '<tr><td>'.$this->Lang('datefora')    . ':</td><td>'.$text.'</td></tr>';
            
            $ret .= '<tr><td>'.$this->Lang('showaddform') . ':</td><td>'.'<input type="checkbox" name="showaddform" ' . ($this->GetPropertyValue('showaddform') == 1 ? ' checked="checked"' : '') . ' value="1">'.'</td></tr>';
            $ret .= '<tr><td>'.$this->Lang('sortasc')     . ':</td><td>'.'<input type="checkbox" name="sortasc" '     . ($this->GetPropertyValue('sortasc')     == 1 ? ' checked="checked"' : '') . ' value="1">'.'</td></tr>';
            $ret .= '<tr><td>'.$this->Lang('smile')       . ':</td><td>'.'<input type="checkbox" name="smiley" '      . ($this->GetPropertyValue('smiley')      == 1 ? ' checked="checked"' : '') . ' value="1">'.'</td></tr>';
            
            if ($this->mod->ModuleIsInstalled('Captcha'))
            {

            	$ret .= '<tr><td>'.$this->Lang('captcha')     . ':</td><td>'.'<input type="checkbox" name="captcha" '     . ($this->GetPropertyValue('captcha')     == 1 ? ' checked="checked"' : '') . ' value="1">'.'</td></tr>';
            }
            $ret .= '<tr><td>'.$this->Lang('shmenow')     . ':</td><td>'.'<input type="checkbox" name="shownow" '     . ($this->GetPropertyValue('shownow')     == 1 ? ' checked="checked"' : '') . ' value="1">'.'</td></tr>';
        }
        
        return $ret;        
	}
	
	
	function Show($param)
	{
		
		
       //$params = array_merge($params, $this->mod->GetModuleParameters($id));
     // return cms_module_plugin($params, $smarty);
      
      if ($param == 'content_en')
		{
			print_r($smarty->params);
	    global $smarty;
		$params1 = array();
		$params1['textleng']    = $this->GetPropertyValue('textleng');
		$params1['number']      = $this->GetPropertyValue('number');
		$params1['mailnoti']    = $this->GetPropertyValue('mailnoti');
		$params1['lang']        = $this->GetPropertyValue('locale');
		$params1['timespan']    = $this->GetPropertyValue('timespan');
		$params1['showaddform'] = $this->GetPropertyValue('showaddform');
		$params1['sortasc']     = $this->GetPropertyValue('sortasc');
		$params1['smiley']      = $this->GetPropertyValue('smiley');
		$params1['captcha']     = $this->GetPropertyValue('captcha');
		$params1['shownow']     = $this->GetPropertyValue('shownow');
		$params1['dateformat']  = $this->GetPropertyValue('dateformat');
		$params1['guestbook']   = $this->GetPropertyValue('guestbook');
      $params1['module']      = 'Guestbook';
      $params1['asplugin']      = 2;

			

			//Buffer all this crap spit out by the persondescription module and return it
			@ob_start();
			echo cms_module_plugin($params1, $smarty);
			$text = @ob_get_contents();
			@ob_end_clean();
			#return $text;
			return '{literal}'.$text.'{/literal}';
		}
		else
		{
			return '';
		}
      
      
      
		//return $text;
        
	}
	
	
	function IsDefaultPossible()
	{
		return TRUE;
	}
	
	function FillParams(&$params)
	{
		$config = cmsms()->GetConfig();
		
		if (isset($params))
		{
			$parameters = array('number', 'sortasc', 'smiley', 'mailnoti', 'textleng', 'shownow', 'dateformat', 'lang', 'showaddform');
			foreach ($parameters as $oneparam)
			{
				if (isset($params[$oneparam]))
				{
					$this->SetPropertyValue($oneparam, $params[$oneparam]);
				}
			}
			
			if (isset($params['title']))
			{
				$this->SetName($params['title']);
			}
			
			if (isset($params['menutext']))
			{
				$this->SetMenuText($params['menutext']);
			}
			
			if (isset($params['template_id']))
			{
				$this->SetTemplateId($params['template_id']);
			}
			
			if (isset($params['alias']))
			{
				$this->SetAlias($params['alias']);
			}
			else
			{
				$this->SetAlias('');
			}
			
			if (isset($params['parent_id']))
			{
				if ($this->mParentId != $params['parent_id'])
				{
					$this->SetHierarchy('');
					$this->SetItemOrder(-1);
				}
				$this->SetParentId($params['parent_id']);
			}
			
			if (isset($params['active']))
			{
				$this->SetActive(true);
			} 
			else 
			{
				$this->SetActive(false);
			}
			
			if (isset($params['showinmenu']))
			{
				$this->SetShowInMenu(true);
			}
			else
			{
				$this->SetShowInMenu(false);
			}
			
			if (isset($params['showaddform']) && $params['showaddform'] == 1)
			{
				$this->SetPropertyValue('showaddform', '1');
			}
			else
			{
				$this->SetPropertyValue('showaddform', '0');
			}
			
			if (isset($params['sortasc']) && $params['sortasc'] == 1)
			{
				$this->SetPropertyValue('sortasc', '1');
			} 
			else
			{
				$this->SetPropertyValue('sortasc', '0');
			}
			
			if (isset($params['shownow']) && $params['shownow'] == 1)
			{
				$this->SetPropertyValue('shownow', '1');
			}
			else
			{
				$this->SetPropertyValue('shownow', '0');
			}
			
			if (isset($params['smiley']) && $params['smiley'] == 1)
			{
				$this->SetPropertyValue('smiley', '1');
			}
			else
			{
				$this->SetPropertyValue('smiley', '0');
			}
			
			if (isset($params['captcha']) && $params['captcha'] == 1)
			{
				$this->SetPropertyValue('captcha', '1');
			}
			else
			{
				$this->SetPropertyValue('captcha', '0');
			}
			
			if (isset($params['lang']) && $params['lang'] != '')
			{
				$this->SetPropertyValue('locale', $params['lang']);
			}
			else
			{
				$this->SetPropertyValue('locale', '');
			}
			
			if (isset($params['timespan']) && $params['timespan'] != '')
			{
				$this->SetPropertyValue('timespan', $params['timespan']);
			}
			else
			{
				$this->SetPropertyValue('timespan', '0');
			}
			
			// Disabling cache to get the annoying bug of empty content from the second load
			$this->SetCachable(false);
			
            // get available guestbooks from the database
        	
			if (isset($params['guestbook']) && isset($guestbooks[$params['guestbook']]))
			{
				$this->SetPropertyValue('guestbook', $params['guestbook']);
			}
			else
			{
				$this->SetPropertyValue('guestbook', $this->GetModuleInstance()->GetPreference('guestbook', '0'));
			}
		}
	}
	
	function FriendlyName()
	{
		return $this->Lang('module_friendlyname');
	}
    
    function TabNames(){
        $res = array(lang('main'));
        if(check_permission(get_userid(),'Manage All Content')){
            $res[] = lang('parameters');
        }
        return $res;
    }
}


?>
