<?php

class GuestbookSmileyHandler
{
	var $SmileysModuleInstance;
	var $ImageBaseURL;
    var $smileylist;
	
	function GuestbookSmileyHandler(&$instance)
	{
		$this->SmileysModuleInstance =& $instance;
        $this->smileylist = array(
				':)'  => 'blush.png',
				':-)' => 'blush.png',
				':('  => 'frown.png',
				':-(' => 'frown.png',
				':D'  => 'biggrin7.png',
				';)' => 'wink2.gif',
				';-)' => 'wink2.gif',
				';('  => 'cry.gif',
				';-(' => 'cry.gif',
				':o'  => 'bigeyes.png',
				'=('  => 'angry.png',
				':P'  => 'srcstic.png',
				'8]'  => 'cool.png',
				'(plane)' => 'plane.gif',
				'(angel)' => 'angel.png',
				'(rain)'  => 'rain.png',
				'(sun)'   => 'sun.png',
				'(moon)'  => 'moon.png',
				'(star)'  => 'star.png',
				'(yes)'   => 'yes.png',
				'(no)'    => 'no.png',
				'(beer)'  => 'beer.png'
			);
	}
	
	/**
	 * Replaces smileys in a text string with images
	 * $param string The text in which to replace the smileys
	 * @return string The text with the smileys replaced
	*/
	function InsertSmileys($text)
	{
		if ($this->SmileysModuleInstance != NULL)
		{
			return $this->SmileysModuleInstance->ReplaceSmileys($text);
		}
		else
		{
			foreach ($this->smileylist as $smiley_txt => $image)
			{
				$smiley_html = '<img src="' . $this->ImageBaseURL . '/' . $image . '"'    . ' title="'.$smiley_txt.'" alt="' . $smiley_txt . '" />';
				$text = str_replace($smiley_txt, $smiley_html, $text);
			}
			return $text;
		}
	}
	
	function ReadSmileyList($listfile,$theme,$unique=false) {
		$lines=@file($listfile);
		if ($lines==false) return false;
		$result=array();
		for ($i=0; $i<count($lines); $i++) {
			if ($lines[$i][0]=="#") continue;
			if (trim($lines[$i])=="") continue;
			$parts=explode(" ",$lines[$i]);

			if (count($parts)<2) continue;
			for($ii=1; $ii<count($parts); $ii++) {
				$alt = htmlentities(trim($parts[1]));
				$result[$parts[0]]=trim($parts[$ii]);
				if ($unique)
					break;
			}

		}
		return $result;
	}

	function GetSmileyList($theme="default",$unique=false) {
		if ($theme=="nosmileys") return false;
		$thistheme=$this->SmileysModuleInstance->GetPreference("defaulttheme","gaim");
		if ($theme!="default") $thistheme=$theme;
		if ($thistheme=="nosmileys") return false;
		$basedir=$this->SmileysModuleInstance->basepath;
		$list=$this->ReadSmileyList($basedir.$thistheme."/".$thistheme.".lst",$thistheme,$unique);

		return $list;
	}
    
    function GetBaseUrl($theme="default"){
		$thistheme=$this->SmileysModuleInstance->GetPreference("defaulttheme","gaim");
		if ($theme!="default") $thistheme=$theme;
        return '/'.$this->SmileysModuleInstance->baseurl.$thistheme.'/';
    }
    
	function GetPopupExampleLink($linkcontent='', $theme="default", $callback="") {
		if ($linkcontent == '') 
			$linkcontent = $this->SmileysModuleInstance->Lang('show_all');

		if ($callback != "")
			$callback = "&amp;callback=".$callback;
		$href = $GLOBALS["config"]["root_url"].'/modules/Smileys/popup.php?theme='.$theme.$callback;
		$js = "
			sw = window.open(this.href, 'smileyswindow', 'width=400,height=270,location=no,menubar=0,resizable=yes,scrollbars=yes'); 
			sw.focus(); 
			return false;
		";
			
		return '<a href="'.$href.'" onclick="'.$js.'">'.$linkcontent.'</a>';			
	}
}

?>
