<?php
#CMS - CMS Made Simple
#(c)2004 by Ted Kulp (wishy@users.sf.net)
#This project's homepage is: http://cmsmadesimple.sf.net
#
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#$Id$

/**
 * @see classes/module/class.Guestbook.php
 * @see class Guestbook
*/

// No direct access
if (!isset($gCms)) 
{
	exit();
}

// Get a reference to the CMS ADOConnection object
$db =& $this->cms->GetDb();

// Create a ADOdb DataDictionary
$dict = NewDataDictionary($db);

// DataDictionary typecode for datetime
$datetime = $gCms->config['use_adodb_lite'] ? 'DT' : 'T';

// Create the guestbook table
$guestbook_table = cms_db_prefix() . 'module_guestbook_guestbook';
$flds = '
    id I KEY NOTNULL,
    name C(255) NOTNULL,
    descr C(255) NOTNULL,
    active I1 DEFAULT 0 NOTNULL
';
$taboptarray = array('mysql' => 'TYPE=MyISAM');
$sqlarray = $dict->CreateTableSQL($guestbook_table, $flds, $taboptarray);
$dict->ExecuteSQLArray($sqlarray);
		
// Insert the default Guestbook
$guestbook_name = $this->Lang('default_guestbook_name');
$guestbook_descr = $this->Lang('default_guestbook_descr');
$default_guestbook_id = $db->GenID(cms_db_prefix() . 'module_guestbook_guestbook_seq');
$sql = "
	INSERT INTO $guestbook_table 
	SET id = $default_guestbook_id, name = '$guestbook_name', descr = '$guestbook_descr', active = 1
	   ";
$db->Execute($sql);

// Create the entry table
$flds = '
	entry_id I KEY,
	guestbook I DEFAULT 0 NOTNULL,
	sender C(255) NOTNULL,
	e_mail C(255) NOTNULL,
	homepage C(255) NOTNULL,
	country C(255) NOTNULL,
	location C(255) NOTNULL,
	message X NOTNULL,
	date ' . $datetime . ' NOTNULL,
	approved I1 DEFAULT 0 NOTNULL,
	ip_address C(15) NOTNULL
';
$taboptarray = array('mysql' => 'TYPE=MyISAM');
$sqlarray = $dict->CreateTableSQL(cms_db_prefix() . 'module_guestbook', $flds, $taboptarray);
$dict->ExecuteSQLArray($sqlarray);

// Create the unique id table
$flds = '
    id I KEY,
    idpost C(255)
';
$taboptarray = array('mysql' => 'TYPE=MyISAM');
$sqlarray = $dict->CreateTableSQL(cms_db_prefix() . 'module_guestbook_post', $flds, $taboptarray);
$dict->ExecuteSQLArray($sqlarray);

// Create the settings table
$flds = '
    setting C(128) KEY,
    value C(255)
';
$taboptarray = array('mysql' => 'TYPE=MyISAM');
$sqlarray = $dict->CreateTableSQL(cms_db_prefix() . 'module_guestbook_settings', $flds, $taboptarray);
$dict->ExecuteSQLArray($sqlarray);

// Create the sequence tables 
// Actually ADOdb would create these automatically when needed - provided the userid has permission to do so
$db->CreateSequence(cms_db_prefix() . "module_guestbook_guestbook_seq");
$db->CreateSequence(cms_db_prefix() . "module_guestbook_seq");
$db->CreateSequence(cms_db_prefix() . "module_guestbook_post_seq");

// Create permissions
$this->CreatePermission('Modify Guestbook Entries' , 'Modify Guestbook Entries');
$this->CreatePermission('Modify Guestbook Settings' , 'Modify Guestbook Settings');
$this->CreatePermission('Modify Guestbook Template', 'Modify Guestbook Templates');

// Set preferences
$this->SetPreference('guestbook', $default_guestbook_id);
$this->SetPreference('number', '10');
$this->SetPreference('textleng', '1000');
$this->SetPreference('timespan', '0');
$this->SetPreference('sortasc', '0');
$this->SetPreference('dateformat', '%d-%m-%Y %H:%M');
$this->SetPreference('shownow', '0');
$this->SetPreference('smiley', '0');
$this->SetPreference('searchsmileys', '0');
$this->SetPreference('captcha', '0');
$this->SetPreference('showaddform', '0');
$this->SetPreference('badwords', '');
$this->SetPreference('badwords_replacement', '####');
$this->SetPreference('wysiwyg', '0');
$this->SetPreference('admin_entries_per_page', '20');
$this->SetPreference('internal_smileys', '0');

// Setup the guestbook (frontend) templates
foreach (
	array(
		'guestbook', 
		'guestbook-entrylist', 
		'guestbook-form', 
		'guestbook-email', 
		'guestbook-showform-button', 
		'guestbook-entry'
	) as $template)
{
	include_once($this->GetModulePath().'/function.templates.php');
    $this->SetTemplate($template, GetGuestbookHtmlTemplate($template,$this->Lang('error_filenotfound_defaulttemplate')));
}

// Insert the stylesheet
$this->InsertStylesheet();

// Create events
if (method_exists($this, 'CreateEvent'))
{
	foreach (array('EntryPosted', 'EntryDeleted', 'EntryActivated', 'EntryDeactivated') as $event)
	{
		$this->CreateEvent('Guestbook' . $event);
	}
}

# vim:ts=4 sw=4 noet
?>
