<?php
#CMS - CMS Made Simple
#(c)2004 by Ted Kulp (wishy@users.sf.net)
#This project's homepage is: http://cmsmadesimple.sf.net
#
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#$Id$

// No direct access
if (!isset($gCms)) 
{
	exit();
}

$db =& $this->cms->GetDb();
$db_prefix = cms_db_prefix();

// delete the stylesheet iserted on install
# get the stylesheet id
$query = "SELECT value FROM {$db_prefix}module_guestbook_settings WHERE setting = 'template_id'";
$result =& $db->Execute($query);
if ($result)
{
    $css_id = $result->Fields('value');
    # delete the stylesheet
    $query = "DELETE FROM {$db_prefix}css WHERE css_id = '$css_id'";
    $result =& $db->Execute($query);
    // delete stylesheet associations
    $query = "DELETE FROM {$db_prefix}css_assoc WHERE assoc_css_id = '$css_id'";
    $result =& $db->Execute($query);
}
// delete the module tables
$dict = NewDataDictionary($db);
// delete the guestbooks table	
$sqlarray = $dict->DropTableSQL($db_prefix . 'module_guestbook_guestbook');
$dict->ExecuteSQLArray($sqlarray);
// delete the entry table	
$sqlarray = $dict->DropTableSQL($db_prefix . 'module_guestbook');
$dict->ExecuteSQLArray($sqlarray);
// delete the unique id table
$sqlarray = $dict->DropTableSQL($db_prefix . 'module_guestbook_post');
$dict->ExecuteSQLArray($sqlarray);
// delete the settings table
$sqlarray = $dict->DropTableSQL($db_prefix . 'module_guestbook_settings');
$dict->ExecuteSQLArray($sqlarray);
// delete the sequence tables if present
$db->DropSequence($db_prefix . 'module_guestbook_guestbook_seq');
$db->DropSequence($db_prefix . 'module_guestbook_seq');
$db->DropSequence($db_prefix . 'module_guestbook_post_seq');

// remove the module permissions
$permissions = array(
	'Modify Guestbook Entries',
	'Modify Guestbook Settings',
	'Modify Guestbook Template'
);
foreach ($permissions as $permission)
{
	$this->RemovePermission($permission);
}

// remove any module content
$query = "SELECT content_id FROM {$db_prefix}content WHERE type = 'guestbookcontent'";
$result =& $db->Execute($query);
if ($result && $result->RecordCount() > 0)
{
    while ($row = $result->FetchRow()) 
    {
        $content_id = $row['content_id'];
        // delete the content
        $query = "DELETE FROM {$db_prefix}content WHERE content_id = '$content_id'";
        $db->Execute($query);
        // delete the contentprops
        $query = "DELETE FROM {$db_prefix}content_props WHERE content_id = '$content_id'";
        $db->Execute($query);
    }
}

// remove preferences
$prefs = array(
		'guestbook',
		'number',
		'textleng',
		'timespan',
		'sortasc',
		'dateformat',
		'shownow',
		'smiley',
		'searchsmileys',
		'captcha',
		'showaddform',
		'badwords',
		'badwords_replacement',
		'wysiwyg',
		'admin_entries_per_page'
			  );
foreach ($prefs as $pref)
{
	$this->RemovePreference($pref);
}

// remove events
if (method_exists($this, 'RemoveEvent'))
{
	foreach (array('EntryPosted', 'EntryDeleted', 'EntryActivated', 'EntryDeactivated') as $event)
	{
		$this->RemoveEvent('Guestbook' . $event);
	}
}

#vim:ts=4 sw=4 noet
?>
