<?php

/**
 * Project:     Pagination's class: based on SmartyPaginate
 * File:        function.paginate_first.php
 * 
 * @author Gabriel MATIAS <gabr.matias [at gmail] somethingagainstspam [and tld:] com> 
 * @author Monte Ohrt <monte at newdigitalgroup dot com>
 * @package Pagination's class
 */

function smarty_function_paginate_first($params, &$smarty) {

    $_id = 'default';
    $_attrs = array();
    
    foreach($params as $_key => $_val) {
        switch($_key) {
            case 'instance':
                if (!Pagination::validArray($_val)) {
                    $smarty->trigger_error('paginate_first: bad pagination instance');
                    return;
                }
                $paginate = $_val;
                break;
            case 'text':
                break;
            default:
                $_attrs[] = $_key . '="' . $_val . '"';
                break;   
        }
    }
    
    
    $_url = $paginate['url'];
    
    $_attrs = !empty($_attrs) ? ' ' . implode(' ', $_attrs) : '';
        
    $page = (($paginate['page_current']>2)?true:false);
    if($page !== false){
        $_text = isset($params['text']) ? $params['text'] : 'first';
        $_url .= (strpos($_url, '?') === false) ? '?' : '&';
        $_url .= $paginate['urlvar'] . '=1';
    }
    
    return ($page) ? '<a href="' . $_url . '"' . $_attrs . '>' . $_text . '</a>' : '';
}

?>
