<?php

/**
 * Project:     Pagination's class: based on SmartyPaginate
 * File:        function.paginate_next.php
 * 
 * @author Gabriel MATIAS <gabr.matias [at gmail] somethingagainstspam [and tld:] com> 
 * @author Monte Ohrt <monte at newdigitalgroup dot com>
 * @package Pagination's class
 */

function smarty_function_paginate_next($params, &$smarty) {

    $_id = 'default';
    $_attrs = array();
    
    foreach($params as $_key => $_val) {
        switch($_key) {
            case 'instance':
                if (!Pagination::validArray($_val)) {
                    $smarty->trigger_error('paginate_next: bad pagination instance');
                    return;
                }
                $paginate = $_val;
                break;
            case 'text':
                break;
            default:
                $_attrs[] = $_key . '="' . $_val . '"';
                break;   
        }
    }
    
    if ($paginate['total'] === false) {
        $smarty->trigger_error("paginate_next: empty total");
        return;        
    }
    
    $_url = $paginate['url'];
    
    $_attrs = !empty($_attrs) ? ' ' . implode(' ', $_attrs) : '';    
    
    $page = (($paginate['page_current'] < $paginate['page_total']) ? ($paginate['page_current']+1) : false);
    if($page !== false) {
        $_show = true;
        $_text = isset($params['text']) ? $params['text'] : 'next';
        $_url .= (strpos($_url, '?') === false) ? '?' : '&';
        $_url .= $paginate['urlvar'] . '=' . $page;
    }
    
    return ($page) ? '<a href="' . $_url . '"' . $_attrs . '>' . $_text . '</a>' : '';
}

?>
